<template>
  <fragment>
    <input
        v-model="pass"
        :disabled="disabled"
        type="password"
        placeholder="Password"
        ref="passInput"
        @input="onInput"
        @keyup.enter="onEnter"
    />
    <div class="complexity-bar-container">
      <div :class="`complexity-bar${complexityBarClassSuffix}`"></div>
    </div>
    <input
        v-model="passConfirmation"
        :disabled="disabled"
        type="password"
        placeholder="Confirm password"
        ref="passConfirmationInput"
        @input="onInput"
        @keyup.enter="onEnter"
    />
  </fragment>
</template>

<script>
  import { PassComplexity } from '../../domain/password'

  export default {
    name: 'InputNewPass',
    props: {
      disabled: Boolean,
      passComplexityCalculator: {
        type: Function,
        default: () => PassComplexity.Medium
      },
      value: {
        type: Object,
        default() { return {
            pass: '',
            passConfirmation: ''
        }}
      }
    },
    data() { return {
      pass: this.value.pass,
      passConfirmation: this.value.passConfirmation
    }},
    computed: {
      passComplexity() {
        return this.passComplexityCalculator(this.pass)
      },
      complexityBarClassSuffix() {
        switch (this.passComplexity) {
          case PassComplexity.Low: return '-low'
          case PassComplexity.Medium: return '-medium'
          case PassComplexity.High: return '-high'
          default: return ''
        }
      }
    },
    methods: {
      onInput() {
        this.$emit('input', {
          pass: this.pass,
          passConfirmation: this.passConfirmation,
          complexity: this.passComplexity
        });
      },
      onEnter() {
        this.$emit('keyup-enter')
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "../color";

  .complexity-bar-container {
    margin-top: -1.75em;
    margin-bottom: 0.75em;
  }

  .complexity-bar {
    display: inline-block;
    height: 0.22em;
  }

  @mixin animate-bar-width($width-from, $width-to) {
    $mixin-id: unique-id();

    width: $width-to;
    animation: width-animation-#{$mixin-id} ease 0.5s;

    @keyframes width-animation-#{$mixin-id} {
      0% {
        width: $width-from;
      }
      100% {
        width: $width-to;
      }
    }
  }

  .complexity-bar-low {
    @extend .complexity-bar;

    background-color: $color-danger;

    @include animate-bar-width(0, 4.4em);
  }

  .complexity-bar-medium {
    @extend .complexity-bar;

    background-color: #F2E931;

    @include animate-bar-width(4.4em, 9em);
  }

  .complexity-bar-high {
    @extend .complexity-bar;

    background-color: $color-success;

    @include animate-bar-width(9em, 13.5em);
  }

  .dark-theme {
    .complexity-bar-low {
      background-color: #c36539;
    }
    .complexity-bar-medium {
      background-color: #dece39;
    }
    .complexity-bar-high {
      background-color: #40bda9;
    }
  }
</style>